library(MASS)

#--------------------------------------------------------------------------
#SHOCK MODEL
#--------------------------------------------------------------------------

#--------------------------------------------------------------------------
# - A FUNCTION THAT CALCULATES THE PROBABILITIES OF FAILURES BASED ON THE 
# - VALUES OF O AND D. THE BAYESIAN APPROACH IS COMMENTED OUT AND STATIC O AND 
# - D IS ASSUMED
#--------------------------------------------------------------------------

probs <- function(n) {
	#Fordeling p D og O
	#----------------------
	#D <- rnorm(1,0.25,0.5) 
	#while( (D >= 0.9) || (D <= 0.1)) {D <- rnorm(1,0.5,0.5)}
	#Q <- rgamma(1,1,1/0.04)
	#while(O >= 1) {O <-rgamma(1,2,8)}
	#-----------------------
	#- Tall for D og O
	D = 1/2
	O <- 1/4
	#---------------------
	r <- O*(1/D-1)
	s <- (1-O)*(1/D-1)
	value <- c()
	for (x in 0:n) {
		value[x+1] <- (factorial(n)/(factorial(x)*(factorial(n-x))))*gamma(r+s)*gamma(x+r)*gamma(n-x+s)/(gamma(r)*gamma(s)*gamma(r+s+n))

	}
	value
}


#--------------------------------------------------------------------------
# - A FUNCTION WHICH MODELLES THE SHOCKS IN CHAPTER 4.3
# - THE FUNCTION CALCULATES THE PFD USING THE probs FUNCTION ABOVE. 
#--------------------------------------------------------------------------

it <- 10000
n <- 3
k <- 2
tau <- 8760
beta <- 0.02
los <- 6.51e-6
nu <- beta *los
t=0
timeGood <- 0
timeBad <- 0


for(i in 1:it) {
	timeGood <- timeGood + tau
	wt <- c()
	k <- 2
	wt[1] <- rexp(1,nu)
	while(sum(wt)< tau) {
		wt[k] <- rexp(1,nu)
		k=k+1
	}
	if(length(wt) > 1) {
		wt <- wt[1:(length(wt)-1)]
	}
		
	if(wt[1] < tau) {
		for(t in 1:length(wt)) {
			u <- runif(length(wt))
			prob <- cumsum(probs(n))
			comdes <- c()
			comdes[1] <- 1
			for(j in 1:(n-1)) {
				if(u[t] < prob[j]) {
					comdes[j] <- 1
	
				}
			}
			
			if(length(comdes) < 2+k) {
				timeGood <- timeGood - (tau + sum(wt[1:t]))
				timeBad <- timeBad + (tau - sum(wt[1:t]))		
			}

		}
	}

}
timeBad/(timeGood+timeBad)
		 	
